Bug 1458441 - Review Request: python-scrypt - Bindings for the scrypt key derivation function library
Summary: Review Request: python-scrypt - Bindings for the scrypt key derivation functi...
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Alfredo Moralejo
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: RDO-PIKE
TreeView+ depends on / blocked
 
Reported: 2017-06-02 22:08 UTC by Haïkel Guémar
Modified: 2017-08-28 12:16 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2017-08-28 12:16:13 UTC
Type: Bug
amoralej: fedora-review+


Attachments (Terms of Use)

Description Haïkel Guémar 2017-06-02 22:08:57 UTC
Spec URL: https://hguemar.fedorapeople.org/reviews/python-scrypt.spec
SRPM URL: https://hguemar.fedorapeople.org/reviews/python-scrypt-0.8.0-1.fc26.src.rpm
Description: Bindings for the scrypt key derivation function library
Fedora Account System Username: hguemar

Comment 1 Alfredo Moralejo 2017-06-06 14:30:54 UTC
Some comments:

- About adding unit tests in %check, unit tests are broken in tarball from pipy as described in https://bitbucket.org/mhallin/py-scrypt/issues/21/test-breaks-importerror-no-module-named

- This package is bundling scrypt release 1.2.0 from https://github.com/Tarsnap/scrypt. As scrypt does not exist in fedora, i understand this is ok and we can go on without using the "Provides: bundled(scrypt)" as shown in https://fedoraproject.org/wiki/Bundled_Libraries?rd=Packaging:Bundled_Libraries

- Package doesn't have a LICENSE file upstream. It'd be nice if it would have one, but license seems correctly set in setup.py

Comment 2 Alfredo Moralejo 2017-06-06 15:31:52 UTC
%{description} macro is not properly expanded in subpackages:

$ rpm -qip python2-scrypt-0.8.0-1.fc27.x86_64.rpm
Name        : python2-scrypt
Version     : 0.8.0
Release     : 1.fc27
Architecture: x86_64
Install Date: (not installed)
Group       : Unspecified
Size        : 62205
License     : BSD
Signature   : (none)
Source RPM  : python-scrypt-0.8.0-1.fc27.src.rpm
Build Date  : Tue 06 Jun 2017 04:59:47 PM CEST
Build Host  : faemino
Relocations : (not relocatable)
URL         : http://bitbucket.org/mhallin/py-scrypt
Summary     : Bindings for the scrypt key derivation function library
Description :
%{description}

Could you fix that, please?

Comment 3 Haïkel Guémar 2017-06-07 10:00:19 UTC
Spec URL: https://hguemar.fedorapeople.org/reviews/python-scrypt.spec
SRPM URL: https://hguemar.fedorapeople.org/reviews/python-scrypt-0.8.0-2.fc26.src.rpm

Fixed, as for the virtual provides, script does not provide any library but a command-line, I'm not sure there are precedents. But anyway, I added them, it can be removed later without consequences.

Comment 4 Alfredo Moralejo 2017-06-07 11:26:31 UTC
You used "bundled(script)", it should be bundled(scrypt) :)

Comment 5 Alfredo Moralejo 2017-06-12 14:31:02 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[-]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "BSD (2 clause)", "Unknown or generated". 34 files have unknown
     license. Detailed output of licensecheck in /tmp/1458441-python-
     scrypt/licensecheck.txt
[-]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     python2-scrypt , python3-scrypt , python-scrypt-debuginfo
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python2-scrypt-0.8.0-2.fc27.x86_64.rpm
          python3-scrypt-0.8.0-2.fc27.x86_64.rpm
          python-scrypt-debuginfo-0.8.0-2.fc27.x86_64.rpm
          python-scrypt-0.8.0-2.fc27.src.rpm
python2-scrypt.x86_64: W: spelling-error %description -l en_US decrypting -> decryption, encrypting, decrying
python2-scrypt.x86_64: W: hidden-file-or-dir /usr/lib/.build-id
python2-scrypt.x86_64: W: hidden-file-or-dir /usr/lib/.build-id
python3-scrypt.x86_64: W: spelling-error %description -l en_US decrypting -> decryption, encrypting, decrying
python3-scrypt.x86_64: W: hidden-file-or-dir /usr/lib/.build-id
python3-scrypt.x86_64: W: hidden-file-or-dir /usr/lib/.build-id
python-scrypt.src: W: spelling-error %description -l en_US decrypting -> decryption, encrypting, decrying
4 packages and 0 specfiles checked; 0 errors, 7 warnings.




Rpmlint (debuginfo)
-------------------
Checking: python-scrypt-debuginfo-0.8.0-2.fc27.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.





Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
python3-scrypt.x86_64: W: spelling-error %description -l en_US decrypting -> decryption, encrypting, decrying
python3-scrypt.x86_64: W: hidden-file-or-dir /usr/lib/.build-id
python3-scrypt.x86_64: W: hidden-file-or-dir /usr/lib/.build-id
python2-scrypt.x86_64: W: spelling-error %description -l en_US decrypting -> decryption, encrypting, decrying
python2-scrypt.x86_64: W: hidden-file-or-dir /usr/lib/.build-id
python2-scrypt.x86_64: W: hidden-file-or-dir /usr/lib/.build-id
3 packages and 0 specfiles checked; 0 errors, 6 warnings.



Requires
--------
python-scrypt-debuginfo (rpmlib, GLIBC filtered):

python3-scrypt (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    libcrypto.so.1.1()(64bit)
    libcrypto.so.1.1(OPENSSL_1_1_0)(64bit)
    libpthread.so.0()(64bit)
    libpython3.6m.so.1.0()(64bit)
    librt.so.1()(64bit)
    python(abi)
    rtld(GNU_HASH)

python2-scrypt (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    libcrypto.so.1.1()(64bit)
    libcrypto.so.1.1(OPENSSL_1_1_0)(64bit)
    libpthread.so.0()(64bit)
    libpython2.7.so.1.0()(64bit)
    librt.so.1()(64bit)
    python(abi)
    rtld(GNU_HASH)



Provides
--------
python-scrypt-debuginfo:
    python-scrypt-debuginfo
    python-scrypt-debuginfo(x86-64)

python3-scrypt:
    bundled(scrypt)
    python3-scrypt
    python3-scrypt(x86-64)
    python3.6dist(scrypt)
    python3dist(scrypt)

python2-scrypt:
    bundled(scrypt)
    python-scrypt
    python-scrypt(x86-64)
    python2-scrypt
    python2-scrypt(x86-64)
    python2.7dist(scrypt)
    python2dist(scrypt)



Unversioned so-files
--------------------
python2-scrypt: /usr/lib64/python2.7/site-packages/_scrypt.so
python3-scrypt: /usr/lib64/python3.6/site-packages/_scrypt.cpython-36m-x86_64-linux-gnu.so

Source checksums
----------------
https://files.pythonhosted.org/packages/source/s/scrypt/scrypt-0.8.0.tar.gz :
  CHECKSUM(SHA256) this package     : d4a5a4f53450b8ef629bbf1ee4be6105c69936e49b3d8bc621ac2287f0c86020
  CHECKSUM(SHA256) upstream package : d4a5a4f53450b8ef629bbf1ee4be6105c69936e49b3d8bc621ac2287f0c86020


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -m fedora-rawhide-x86_64 -b 1458441
Buildroot used: fedora-rawhide-x86_64
Active plugins: Python, Generic, Shell-api, C/C++
Disabled plugins: Java, SugarActivity, fonts, Haskell, Ocaml, Perl, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6


Some comments:

- As stated in previous comment unit tests can't be run because of issue reported in https://bitbucket.org/mhallin/py-scrypt/issues/21/test-breaks-importerror-no-module-named

- A issue has been opened upstream to include a license file, https://bitbucket.org/mhallin/py-scrypt/issues/31/please-include-license-file-in-source

- package is bundling scrypt library non existing in fedora, what i think it's acceptable and a provides bundled(scrypt) has been added. python-scrypt has been licensed under the same license as bundled library.

This package is APPROVED

Comment 6 Gwyn Ciesla 2017-06-12 16:46:14 UTC
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/python-scrypt


Note You need to log in before you can comment on or make changes to this bug.